> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.meshapi.ai/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.meshapi.ai/_mcp/server.

# Router Select

POST https://api.meshapi.ai/v1/router/select
Content-Type: application/json

Resolve the Auto Router's model choice for a prompt without running inference.

Reference: https://developers.meshapi.ai/api-reference/mesh-api/auto-router/router-select

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: openapi
  version: 1.0.0
paths:
  /v1/router/select:
    post:
      operationId: router-select
      summary: Router Select
      description: >-
        Resolve the Auto Router's model choice for a prompt without running
        inference.
      tags:
        - autoRouter
      parameters:
        - name: Authorization
          in: header
          description: Bearer authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/RouterSelectResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/RouterSelectRequest'
servers:
  - url: https://api.meshapi.ai
    description: Production Server
components:
  schemas:
    MessageRole:
      type: string
      enum:
        - system
        - user
        - assistant
        - tool
      title: MessageRole
    ContentPartType:
      type: string
      enum:
        - text
        - image_url
        - video_url
        - input_audio
      title: ContentPartType
    ImageUrlDetail:
      type: string
      enum:
        - auto
        - low
        - high
      default: auto
      title: ImageUrlDetail
    ImageUrl:
      type: object
      properties:
        url:
          type: string
        detail:
          $ref: '#/components/schemas/ImageUrlDetail'
      required:
        - url
      title: ImageUrl
    VideoUrl:
      type: object
      properties:
        url:
          type: string
      required:
        - url
      title: VideoUrl
    InputAudioFormat:
      type: string
      enum:
        - wav
        - mp3
        - aiff
        - aac
        - ogg
        - flac
        - m4a
        - pcm16
        - pcm24
      title: InputAudioFormat
    InputAudio:
      type: object
      properties:
        data:
          type:
            - string
            - 'null'
        uri:
          type:
            - string
            - 'null'
        url:
          type:
            - string
            - 'null'
        format:
          $ref: '#/components/schemas/InputAudioFormat'
      required:
        - format
      title: InputAudio
    ContentPart:
      type: object
      properties:
        type:
          $ref: '#/components/schemas/ContentPartType'
        text:
          type:
            - string
            - 'null'
        image_url:
          oneOf:
            - $ref: '#/components/schemas/ImageUrl'
            - type: 'null'
        video_url:
          oneOf:
            - $ref: '#/components/schemas/VideoUrl'
            - type: 'null'
        input_audio:
          oneOf:
            - $ref: '#/components/schemas/InputAudio'
            - type: 'null'
        fps:
          type:
            - string
            - 'null'
        cache_control:
          type:
            - object
            - 'null'
          additionalProperties:
            description: Any type
      required:
        - type
      title: ContentPart
    MessageContent1:
      type: array
      items:
        $ref: '#/components/schemas/ContentPart'
      title: MessageContent1
    MessageContent:
      oneOf:
        - type: string
        - $ref: '#/components/schemas/MessageContent1'
      title: MessageContent
    ToolCall:
      type: object
      properties:
        id:
          type: string
        type:
          type: string
          enum:
            - function
        function:
          type: object
          additionalProperties:
            description: Any type
        thought_signature:
          type:
            - string
            - 'null'
      required:
        - id
        - function
      title: ToolCall
    Message:
      type: object
      properties:
        role:
          $ref: '#/components/schemas/MessageRole'
        content:
          oneOf:
            - $ref: '#/components/schemas/MessageContent'
            - type: 'null'
        name:
          type:
            - string
            - 'null'
        tool_call_id:
          type:
            - string
            - 'null'
        tool_calls:
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/ToolCall'
        reasoning_details:
          type:
            - array
            - 'null'
          items:
            type: object
            additionalProperties:
              description: Any type
        cache_control:
          type:
            - object
            - 'null'
          additionalProperties:
            description: Any type
      required:
        - role
      title: Message
    RouterSelectRequestApiType:
      type: string
      enum:
        - completions
        - responses
        - embeddings
      default: completions
      title: RouterSelectRequestApiType
    RouterSelectRequest:
      type: object
      properties:
        messages:
          type: array
          items:
            $ref: '#/components/schemas/Message'
        api_type:
          $ref: '#/components/schemas/RouterSelectRequestApiType'
        exclude_models:
          type:
            - array
            - 'null'
          items:
            type: string
        candidate_models:
          type:
            - array
            - 'null'
          items:
            type: string
      required:
        - messages
      title: RouterSelectRequest
    AutoRouterMeta:
      type: object
      properties:
        fallback_used:
          type: boolean
          default: false
        fallback_reason:
          type:
            - string
            - 'null'
      title: AutoRouterMeta
    RouterSelectResponseReasoningEffort:
      type: string
      enum:
        - high
        - medium
        - low
        - none
      title: RouterSelectResponseReasoningEffort
    RouterSelectResponse:
      type: object
      properties:
        model:
          type: string
        auto_router:
          $ref: '#/components/schemas/AutoRouterMeta'
        reasoning_effort:
          oneOf:
            - $ref: '#/components/schemas/RouterSelectResponseReasoningEffort'
            - type: 'null'
      required:
        - model
        - auto_router
      title: RouterSelectResponse
    ValidationErrorLocItems:
      oneOf:
        - type: string
        - type: integer
      title: ValidationErrorLocItems
    ValidationErrorCtx:
      type: object
      properties: {}
      title: ValidationErrorCtx
    ValidationError:
      type: object
      properties:
        loc:
          type: array
          items:
            $ref: '#/components/schemas/ValidationErrorLocItems'
        msg:
          type: string
        type:
          type: string
        input:
          description: Any type
        ctx:
          $ref: '#/components/schemas/ValidationErrorCtx'
      required:
        - loc
        - msg
        - type
      title: ValidationError
    HTTPValidationError:
      type: object
      properties:
        detail:
          type: array
          items:
            $ref: '#/components/schemas/ValidationError'
      title: HTTPValidationError
  securitySchemes:
    HTTPBearer:
      type: http
      scheme: bearer

```

## Examples

### Example response



**Request**

```json
undefined
```

**Response**

```json
{
  "model": "anthropic/claude-haiku-4.5",
  "auto_router": {
    "selected": true,
    "strategy": "registry",
    "reason": "Best latency-adjusted fit for the prompt and API type."
  },
  "reasoning_effort": "none"
}
```

**SDK Code**

```python Example response
import requests

url = "https://api.meshapi.ai/v1/router/select"

headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, headers=headers)

print(response.json())
```

```javascript Example response
const url = 'https://api.meshapi.ai/v1/router/select';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: undefined
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Example response
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.meshapi.ai/v1/router/select"

	req, _ := http.NewRequest("POST", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example response
require 'uri'
require 'net/http'

url = URI("https://api.meshapi.ai/v1/router/select")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'

response = http.request(request)
puts response.read_body
```

```java Example response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.meshapi.ai/v1/router/select")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .asString();
```

```php Example response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.meshapi.ai/v1/router/select', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Example response
using RestSharp;

var client = new RestClient("https://api.meshapi.ai/v1/router/select");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
IRestResponse response = client.Execute(request);
```

```swift Example response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.meshapi.ai/v1/router/select")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Example request



**Request**

```json
{
  "messages": [
    {
      "role": "user",
      "content": "Write a SQL query for monthly revenue."
    }
  ],
  "api_type": "completions",
  "exclude_models": [
    "openai/gpt-4o-mini"
  ],
  "candidate_models": [
    "openai/gpt-4o-mini",
    "anthropic/claude-haiku-4.5",
    "openai/gpt-5.4"
  ]
}
```

**Response**

```json
{
  "model": "anthropic/claude-haiku-4.5",
  "auto_router": {
    "selected": true,
    "strategy": "registry",
    "reason": "Best latency-adjusted fit for the prompt and API type."
  },
  "reasoning_effort": "none"
}
```

**SDK Code**

```python Example request
import requests

url = "https://api.meshapi.ai/v1/router/select"

payload = {
    "messages": [
        {
            "role": "user",
            "content": "Write a SQL query for monthly revenue."
        }
    ],
    "api_type": "completions",
    "exclude_models": ["openai/gpt-4o-mini"],
    "candidate_models": ["openai/gpt-4o-mini", "anthropic/claude-haiku-4.5", "openai/gpt-5.4"]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Example request
const url = 'https://api.meshapi.ai/v1/router/select';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"messages":[{"role":"user","content":"Write a SQL query for monthly revenue."}],"api_type":"completions","exclude_models":["openai/gpt-4o-mini"],"candidate_models":["openai/gpt-4o-mini","anthropic/claude-haiku-4.5","openai/gpt-5.4"]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Example request
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.meshapi.ai/v1/router/select"

	payload := strings.NewReader("{\n  \"messages\": [\n    {\n      \"role\": \"user\",\n      \"content\": \"Write a SQL query for monthly revenue.\"\n    }\n  ],\n  \"api_type\": \"completions\",\n  \"exclude_models\": [\n    \"openai/gpt-4o-mini\"\n  ],\n  \"candidate_models\": [\n    \"openai/gpt-4o-mini\",\n    \"anthropic/claude-haiku-4.5\",\n    \"openai/gpt-5.4\"\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example request
require 'uri'
require 'net/http'

url = URI("https://api.meshapi.ai/v1/router/select")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"messages\": [\n    {\n      \"role\": \"user\",\n      \"content\": \"Write a SQL query for monthly revenue.\"\n    }\n  ],\n  \"api_type\": \"completions\",\n  \"exclude_models\": [\n    \"openai/gpt-4o-mini\"\n  ],\n  \"candidate_models\": [\n    \"openai/gpt-4o-mini\",\n    \"anthropic/claude-haiku-4.5\",\n    \"openai/gpt-5.4\"\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Example request
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.meshapi.ai/v1/router/select")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"messages\": [\n    {\n      \"role\": \"user\",\n      \"content\": \"Write a SQL query for monthly revenue.\"\n    }\n  ],\n  \"api_type\": \"completions\",\n  \"exclude_models\": [\n    \"openai/gpt-4o-mini\"\n  ],\n  \"candidate_models\": [\n    \"openai/gpt-4o-mini\",\n    \"anthropic/claude-haiku-4.5\",\n    \"openai/gpt-5.4\"\n  ]\n}")
  .asString();
```

```php Example request
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.meshapi.ai/v1/router/select', [
  'body' => '{
  "messages": [
    {
      "role": "user",
      "content": "Write a SQL query for monthly revenue."
    }
  ],
  "api_type": "completions",
  "exclude_models": [
    "openai/gpt-4o-mini"
  ],
  "candidate_models": [
    "openai/gpt-4o-mini",
    "anthropic/claude-haiku-4.5",
    "openai/gpt-5.4"
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Example request
using RestSharp;

var client = new RestClient("https://api.meshapi.ai/v1/router/select");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"messages\": [\n    {\n      \"role\": \"user\",\n      \"content\": \"Write a SQL query for monthly revenue.\"\n    }\n  ],\n  \"api_type\": \"completions\",\n  \"exclude_models\": [\n    \"openai/gpt-4o-mini\"\n  ],\n  \"candidate_models\": [\n    \"openai/gpt-4o-mini\",\n    \"anthropic/claude-haiku-4.5\",\n    \"openai/gpt-5.4\"\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Example request
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "messages": [
    [
      "role": "user",
      "content": "Write a SQL query for monthly revenue."
    ]
  ],
  "api_type": "completions",
  "exclude_models": ["openai/gpt-4o-mini"],
  "candidate_models": ["openai/gpt-4o-mini", "anthropic/claude-haiku-4.5", "openai/gpt-5.4"]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.meshapi.ai/v1/router/select")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```